/**
  * NoProporcional.java
  * Clase para describir los objetos de reaseguro no proporcionales, la proporcion de la prima y siniestro para la reaseguradora es distinta
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

import java.util.Scanner;
abstract public  class NoProporcional extends Reaseguro{

      protected double proporcionSiniestro;
      protected double proporcionPrima;

     /** Constructor con parametros
      *@param sas - Cantidad total que se asegura
      *@param ps - Prima total que se paga por cubrir el riesgo del seguro
      */
      public NoProporcional(double sas, double ps){
		  super(sas,ps);
		  proporcionSiniestro=0;
		  proporcionPrima=0;
	 }

      public abstract double calculoProporcionSiniestro();

    /** Se determina la Porporcion de la prima que sera para la aseguradora
     *@return double - proporcion
     */
      public double calculoProporcionPrima(){
		  Scanner lectura = new Scanner(System.in);
		  double proporcion = 0;
		  do{
		  System.out.print("Cual es la proporcion de la Prima especificada en el contrato de Reaseguro para este tipo de seguro?");
		  proporcion = lectura.nextDouble();
			  if(proporcion<0||proporcion>1)
			       System.out.print("Cantidad no adecuada");
		 }while(proporcion<0 || proporcion >1);
		  return proporcion;
	  }

    /** Metodo para determinar la proporcion cantidad del siniestro que es responsabilidad de la reaseguradora
     *@return double - monto del siniestro que cubriria la reaseguradora
     */
      public double calculoSiniestroReaseguro(){
		  return sumaAseguradaSeguro * proporcionSiniestro;
      }

    /** Metodo para determinar la cantidad de la Prima que sera para la reaseguradora
     *@return double - pago a la reaseguradora por cubrir el riesgo
     */
      public double calcularPrimaReaseguro(){
		  return primaSeguro*proporcionPrima;
	  }


      /**
       *
       *Metodos Obtener y Modificar
       *
       **/


	   public void modificarProporcionSiniestro(double prop){
		   proporcionSiniestro = prop;
	   }

	   public double obtenerProporcionSiniestro(){
		   return proporcionSiniestro;
	   }

	   public void modificarProporcionPrima(double prop){
		   proporcionPrima = prop;
	   }

	   public double obtenerProporcionPrima(){
		   return proporcionPrima;
	   }

}//Fin de la Clase