/**
  * PorExcedente.java
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

public  class PorExcedente extends Proporcional{

     /** Constructor con parametros
      *@param sas - Cantidad total que se asegura
      *@param ps - Prima total que se paga por cubrir el riesgo del seguro
      */
      public PorExcedente(double sas, double ps){
		  super(sas,ps);
		  proporcion=calculoProporcion();
		  cantidadSiniestroReaseguro = calculoSiniestroReaseguro();
	      cantidadPrimaReaseguro = calcularPrimaReaseguro();
	  }

     /** Determina la proporcion tanto de la prima como del siniestro
      *@return double - proporcion
      */
      public double calculoProporcion(){
		  double proporcion = 0;
		  if(sumaAseguradaSeguro<1000000)
		      proporcion = 0;
		  else if(sumaAseguradaSeguro<10000000)
		      proporcion = .2;
		  else if(sumaAseguradaSeguro<100000000)
		      proporcion = .4;
		  else
		      proporcion = .6;
		 return proporcion;
	  }
}//Fin de la Clase