/**
  * Proporcional.java
  * Clase para describir los reaseguros proporcionales en los cuales se da la misma proporcion de la prima y siniestro a la reaseguradora
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

abstract public  class Proporcional extends Reaseguro{

      protected double proporcion;

     /** Constructor con parametros
      *@param sas - Cantidad total que se asegura
      *@param ps - Prima total que se paga por cubrir el riesgo del seguro
      */
      public Proporcional(double sas, double ps){
		  super(sas,ps);
		  proporcion=0;
	 }

      public abstract double calculoProporcion();

    /** Metodo para determinar la proporcion cantidad del siniestro que es responsabilidad de la reaseguradora
     *@return double - monto del siniestro que cubriria la reaseguradora
     */
      public double calculoSiniestroReaseguro(){
		  return sumaAseguradaSeguro * proporcion;
      }

    /** Metodo para determinar la cantidad de la Prima que sera para la reaseguradora
     *@return double - pago a la reaseguradora por cubrir el riesgo
     */
      public double calcularPrimaReaseguro(){
		  return primaSeguro*proporcion;
	  }


      /**
       *
       *Metodos Obtener y Modificar
       *
       **/


	   public void modificarProporcion(double prop){
		   proporcion = prop;
	   }

	   public double obtenerProporcion(){
		   return proporcion;
	   }

}//Fin de la Clase