/**
  * Reaseguro.java
  *Clase abstracta para cualquier tipo de reaseguro
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

abstract public  class Reaseguro{

      protected double sumaAseguradaSeguro;
      protected double primaSeguro;
      protected double cantidadSiniestroReaseguro;
      protected double cantidadPrimaReaseguro;

     /** Constructor con parametros
      *@param sas - Cantidad total que se asegura
      *@param ps - Prima total que se paga por cubrir el riesgo del seguro
      */
     public Reaseguro(double sas, double ps){
		  sumaAseguradaSeguro = sas;
		  primaSeguro = ps;
	      cantidadSiniestroReaseguro = 0;
	      cantidadPrimaReaseguro = 0;
	 }

      public abstract double calculoSiniestroReaseguro();

      public abstract double calcularPrimaReaseguro();



      /**
       *
       *Metodos Obtener y Modificar
       *
       **/


	   public void modificarSAS(double sas){
		   sumaAseguradaSeguro = sas;
	   }

	   public double obtenerSAS(){
		   return sumaAseguradaSeguro;
	   }

	   public void modificarPS(double ps){
		   primaSeguro = ps;
	   }

	   public double obtenerPS(){
		   return primaSeguro;
	   }

	   public void modificarCSR(double csr){
		   cantidadSiniestroReaseguro = csr;
	   }

	   public double obtenerCSR(){
		   return cantidadSiniestroReaseguro;
	   }

	   public void modificarCPR(double cpr){
		   cantidadPrimaReaseguro = cpr;
	   }

	   public double obtenerCPR(){
		   return cantidadPrimaReaseguro;
	   }
}//Fin de la Clase