/**
  * Busqueda.java
  * Clase con metodos para realizar la busqueda y ordenacion
  * @author  Erick Santillan
  * @version  Abril 2010
  */
import java.util.Calendar;
public class BO{

     /** Constructor sin parametros
      *
      */
   public BO(){
	   super();
   }

     /** Realiza la busqueda de un dato en una lista mediante el algoritmo de busqueda lineal
      *@param datos - conjunto de datos
      *@param num - numeor a buscar en la lista
      *@return int - lugar en que se encuentra dentro de la lista
      */
   static int busquedaLineal(double[] datos, double num){
          int resultado = -1;
          for(int i=0;i<datos.length;i++){
			  if(datos[i]==num){
				  resultado = i;
				  i=datos.length;
			  }
		  }
		  return resultado;
   }

     /** Realiza el ordenamiento de una lista mediante el algoritmo de ordenamiento por seleccion
      *@param datos - conjunto de datos
      *@return double[] - conjunto de datos ordenado
      */
   static double[] ordenamientoSeleccion(double[] datos) {
   	for (int i = 0; i < datos.length - 1; i++){
   		int min = i;
   		for (int j = i + 1; j < datos.length; j++){
   			if (datos[j] < datos[min]){
   				min = j;
   			}
   		}
   		if (i != min) {
   			double aux= datos[i];
   			datos[i] = datos[min];
   			datos[min] = aux;
   		}
   	  }
   	  return datos;
   }

     /** Realiza el ordenamiento de una lista mediante el algoritmo de ordenamiento por insercion
      *@param datos - conjunto de datos
      *@return double[] - conjunto de datos ordenado
      */
   static double[]  ordenamientoInsercion(double[] datos){
      for (int i=1; i<datos.length; i++) {
         double aux = datos[i];
         int j;
         for (j=i-1; j>=0 && datos[j]>aux; j--)
            datos[j+1] = datos[j];
         datos[j+1] = aux;
      }
      return datos;
   }


     /** Realiza la busqueda de un dato en una lista mediante el algoritmo de busqueda binaria
      *@param datos - conjunto de datos
      *@param num - numeor a buscar en la lista
      *@return int - lugar en que se encuentra dentro de la lista
      */
    static int busquedaBinaria( double [] datos, double num) {
       int inicio = 0;
       int fin = datos.length - 1;
       int pos=0;
       int resultado = -1;
       while (inicio <= fin) {
           pos = (inicio+fin) / 2;
           if ( datos[pos] == num ){
             resultado = pos;
             inicio=fin+1;
           }else{
			  if ( datos[pos] < num ) {
                 inicio = pos+1;
              } else {
                 fin = pos-1;
              }
           }
       }
       return resultado;
   }


}//Fin de la Clase