/**
  * Estadistica.java
  * Clase para realizar el analisis de estadistica descriptiva a un conjunto de datos
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

public class Estadistica{
   private double[] datos;

     /** Constructor con parametro
      *@param dat - Conjunto de datos a analizar
      */
   public Estadistica(double[] dat){
	   datos=dat;
   }

     /** Calculo de la media del conjunto de datos
      *@return double - media = suma de datos / n
      */
   public double media(){
	       double media=0;
	   try{
	       int tamano=datos.length;
	       for(int i=0;i<tamano;i++)
	          media+=datos[i];
	       media/=tamano;
	       return media;
       }catch(Exception e){
		   System.out.println("Excepcion al calcular la media");
		   System.out.println(e);
	   }finally{
		   return media;
	   }
   }

     /** Calculo de la mediana del conjunto de datos
      *@return double- mediana= dato que se encuentra a la mitad del conjunto ordenado
      */
   public double mediana(){
	   double resultado=0;
	   try{
           int tamano=datos.length;
           int opcion =tamano % 2;
           if(opcion==0){
		     resultado=datos[tamano/2];
	      }else{
		     resultado=datos[(tamano+1)/2];
	       }
       }catch(Exception e){
		   System.out.println("Excepcion al calcular la media");
		   System.out.println(e);
	   }finally{
             return resultado;
       }
   }

     /** Calculo de la Varianza del conjunto de datos
      *@return double- varianza=(suma(dato-media)^2)/n-1
      */
   public double varianzaMuestral(){
       double varianza = 0;
       try{
			double media=media();
            int tamano=datos.length;
            for(int i =0; i < tamano;i++){
		    	 varianza+=(datos[i]-media)*(datos[i]-media);
	       }
           varianza/=tamano-1;
       }catch(Exception e){
		   System.out.println("Excepcion al calcular la media");
		   System.out.println(e);
	   }finally{
            return varianza;
       }
   }

     /** Cambiar el conjunto de datos
      *@param dat- conjunto de datos apra analizar
      */
   public void modificarDatos(double[] dat){
	   datos=dat;
   }

     /** Obtener el conjunto de datos
      *@return double[]- lista de datos
      */
   public double[] obtenerDatos(){
	   return datos;
   }

}//Fin de la Clase