/**
  * Main.java
  * @author  Erick Santillan
  * @version  Marzo 2010
  */

import java.util.Scanner;
public class Main{

     /** Metodo Principal
      */
   public static void main(String[] pps)throws Exception{
       Scanner io = new Scanner(System.in);
       double[] datos=new double[0];
       boolean correcto=false;
       int cantidad=0;

       System.out.println("Bienvenido al Sistema de Estadistica Descriptiva");

       //Preguntar por la cantidad de datos
       do{
		  System.out.println("Cuantos datos se van a ingresar para su analisis?");
          try{
             cantidad = io.nextInt();
             datos = new double[cantidad];
	         correcto=true;
	      }catch(NumberFormatException e){
			 System.out.println("No se indica una entero como cantidad");
		  }catch(NegativeArraySizeException e){
			 System.out.println("No se indica una cantidad positiva de numeros");
		  }
       }while(!correcto);

       //No se pueden analizar menos de 2 datos
       if(cantidad<2)
           throw new ExcepcionEstadistica("No se puede realizar con menos de 2 datos");

       //Preguntar el tipo de dato
       boolean enteros = false;
       correcto = false;
       do{
          System.out.println("De que tipo seran los datos?");
          System.out.println("1. Enteros");
          System.out.println("2. Reales");
          try{
             int opcion = io.nextInt();
             if(opcion==1){
                  enteros = true;
                  correcto=true;
		     }else if(opcion==2){
                  enteros = false;
                  correcto=true;
		     }else{
                  System.out.println("Solo se acepta 1 o 2 como opcion");
		     }
	      }catch(NumberFormatException e){
			 System.out.println("Solo se acepta 1 o 2 como opcion");
		  }
       }while(!correcto);

       //Se quita la siguiente linea
       //io.println("Solo se aceptan el ingreso de datos ordenados, de menor a mayor");

       //Ingresar el conjunto de datos
       for(int i=0; i<cantidad;i++){
		   correcto=false;
		   double dato=0;
		   do{
		        System.out.println("Indica el dato "+(i+1));
		        if(enteros){
					try{
				         int datoEntero = io.nextInt();
				         dato=(double) datoEntero;
				         correcto=true;
				    }catch(NumberFormatException e){
					   	   System.out.println("Solo se aceptan enteros");
		            }
			    }else{
					try{
				         dato=io.nextDouble();
				         correcto=true;
				    }catch(NumberFormatException e){
					   	   System.out.println("Solo se aceptan reales");
		            }
			    }
		   }while(!correcto);
           datos[i]=dato;

           /*Se quitan las siguientes lineas
           if(i>0)
              if(datos[i]<datos[i-1])
                 throw new ExcepcionEstadistica("Los datos deben ingresarse de menor a mayor");
           */
	   }

      //Crear objeto para analisis
      datos = BO.ordenamientoInsercion(datos);
      Estadistica analisis = new Estadistica(datos);
      //Mostrar Resultados
      System.out.println("Analisis de los Datos");
      System.out.println("Media:"+ analisis.media());
      System.out.println("Mediana:"+ analisis.mediana());
      System.out.println("Media:"+ analisis.varianzaMuestral());

     //Agregar Funcionalidad
     int opcion =0;
     do{
		 System.out.println("Selecciona una Opcion");
		 System.out.println("1.Mostrar datos ordenados");
		 System.out.println("2.Buscar un dato");
         System.out.println("3.Salir");
         opcion = io.nextInt();
		 if(opcion==1){
			 int tam = datos.length;
			 System.out.println("DATO;");
			 for(int i=0;i<tam;i++)
			    System.out.println(datos[i]);

	     }else if(opcion==2){
			 System.out.println("Que dato desea buscar?");
			 double num = io.nextDouble();
			 int pos = BO.busquedaBinaria(datos,num);
			 if(pos==-1)
			     System.out.println("No se encontro el dato");
			 else
			     System.out.println("Se encuentra en la posicion; "+(pos+1));
		}
	 }while(opcion==1||opcion==2);


   }
}//Fin de la Clase