/**
  * Recursion.java
  * Desarrollar metodos que ocupan la recursion para llegar a la solucion deseada
  * @author  Erick Santillan
  * @version  junio 2010
  */

import java.util.Scanner;
public class Recursion{

    /** Metodo para determinar el resultado de la primer Formula que se plantea en e ejercicio
     *@param n - limite de la sumatoria
     *@return int - Resultado de la Formula
     */
	public static int Formula1(int n){
		if(n==1)
		     return 3;
		else
		   return  Formula1(n-1)+(int)(Math.pow(3,n)*((2*n)-1));

   }

    /** Metodo para determinar el resultado de la segunda Formula que se plantea en el ejercicio
     *@param n - exponente del 7 en la formula  (7^n-1)
     *@return int - Elemnto de los naturales que da valor a x   (7^n-1=6x)
     */
   public static int Formula2(int n){
	   if(n==1)
	        return 1;
	   else
	        return Formula2(n-1)+(int)Math.pow(7,n-1);
   }

    /** Metodo para determinar la probabilidad de que una persona de edad x llegue con vida a edad x+k
     *@param lista - lista con probabilidad de muerte en cada anio. Probabilidad de que a en edad x no llegue a edad x+1
     *@param x - edad inicial
     *@param k - anios a que se calcula la probabilidad de sobrevivencia
     *@return double - Probabilidad de vivir k anios
     */
   public static double probRecursion(double[] lista, int x, int k){
	   if(k==0)
	       return 1;
	   else
	       return probRecursion(lista,x,k-1)*(1-lista[x+k-1]);
   }

    /** Metodo principal para mostrar funcionalidad de los metodos planteados
     */
   public static void main(String[] pps)throws Exception{
       Scanner io = new Scanner(System.in);
       System.out.println("Indicar cantidad a calcular con la Formula 1");
       int n = io.nextInt();
       System.out.println("Resultado: "+ Formula1(n));
       System.out.println("Indicar cantidad a calcular con la Formula 2");
	   n = io.nextInt();
       System.out.println("Resultado: "+ Formula2(n));

       //lista de probabilidades de muerte a cada edad
       double[] lista=crearLista();
       System.out.println("Indicar las cantidades para calcular la probabilidad de sobrevivencia");
       System.out.println("Valor para x (edad)?");
	   int x= io.nextInt();
	   System.out.println("Valor para k (anios de sobrevivencia)?");
	   int k= io.nextInt();
       System.out.println("Resultado: "+ probRecursion(lista, x,k));

 }

    /** Metodo para crear la lista de probabilidades para realizar un ejemplo
     *@return double[] - Arreglo con los valores de las probabilidades de muerte
     */
    public static double[] crearLista(){
		 double[] lista=new double[101];
		       lista[0]=0;
		       lista[1]=0;
		       lista[2]=0;
		       lista[3]=0;
		       lista[4]=0;
		       lista[5]=0;
		       lista[6]=0;
		       lista[7]=0;
		       lista[8]=0;
		       lista[9]=0;
		       lista[10]=0;
		       lista[11]=0;
		       lista[12]=0.000396;
			   lista[13]=0.000427;
			   lista[14]=0.00046;
			   lista[15]=0.000495;
			   lista[16]=0.000533;
			   lista[17]=0.000575;
			   lista[18]=0.000619;
			   lista[19]=0.000667;
			   lista[20]=0.000718;
			   lista[21]=0.000773;
			   lista[22]=0.000833;
			   lista[23]=0.000897;
			   lista[24]=0.000966;
			   lista[25]=0.001041;
			   lista[26]=0.001121;
			   lista[27]=0.001207;
			   lista[28]=0.0013;
			   lista[29]=0.0014;
			   lista[30]=0.001508;
			   lista[31]=0.001624;
			   lista[32]=0.001749;
			   lista[33]=0.001884;
			   lista[34]=0.002029;
			   lista[35]=0.002186;
			   lista[36]=0.002354;
			   lista[37]=0.002535;
			   lista[38]=0.00273;
			   lista[39]=0.00294;
			   lista[40]=0.003166;
			   lista[41]=0.00341;
			   lista[42]=0.003672;
			   lista[43]=0.003954;
			   lista[44]=0.004258;
			   lista[45]=0.004585;
			   lista[46]=0.004938;
			   lista[47]=0.005317;
			   lista[48]=0.005725;
			   lista[49]=0.006164;
			   lista[50]=0.006637;
			   lista[51]=0.007145;
			   lista[52]=0.007693;
			   lista[53]=0.008282;
			   lista[54]=0.008915;
			   lista[55]=0.009597;
			   lista[56]=0.01033;
			   lista[57]=0.011119;
			   lista[58]=0.011967;
			   lista[59]=0.012879;
			   lista[60]=0.01386;
			   lista[61]=0.014914;
			   lista[62]=0.016048;
			   lista[63]=0.017265;
			   lista[64]=0.018574;
			   lista[65]=0.01998;
			   lista[66]=0.02149;
			   lista[67]=0.023111;
			   lista[68]=0.024851;
			   lista[69]=0.02672;
			   lista[70]=0.028724;
			   lista[71]=0.030874;
			   lista[72]=0.03318;
			   lista[73]=0.035651;
			   lista[74]=0.0383;
			   lista[75]=0.041136;
			   lista[76]=0.044174;
			   lista[77]=0.047424;
			   lista[78]=0.050902;
			   lista[79]=0.054619;
			   lista[80]=0.058592;
			   lista[81]=0.062834;
			   lista[82]=0.067362;
			   lista[83]=0.07219;
			   lista[84]=0.077337;
			   lista[85]=0.082817;
			   lista[86]=0.088649;
			   lista[87]=0.09485;
			   lista[88]=0.101436;
			   lista[89]=0.108424;
			   lista[90]=0.115832;
			   lista[91]=0.123677;
			   lista[92]=0.131973;
			   lista[93]=0.140737;
			   lista[94]=0.149983;
			   lista[95]=0.159723;
			   lista[96]=0.16997;
			   lista[97]=0.180733;
			   lista[98]=0.19202;
			   lista[99]=0.203837;
	           lista[100]=1;
		       return lista;
   }

}//Fin de la Clase