/**
  * Main.java
  * @author  Erick Santillan
  * @version  Junio2010
  */
import java.util.Scanner;
import java.io.*;

public class Main{


    /** Metodo Principal
     */
    public static void main(String[] args){
		Scanner io = new Scanner(System.in);
		//Mensaje de Bienvenida
        System.out.println("Bienvenido al Sistema de Polizas");
        //Mostrar Opciones
        int respuesta=1;
        Poliza poliza1 = null;

        do{
               System.out.println("Que accion desea realizar");
               System.out.println("1.Cargar Poliza");
               System.out.println("2.Crear Nueva Poliza");
               respuesta = io.nextInt();
               switch(respuesta){
                     case 1:
                           //Mostrar datos de la Poliza
                           System.out.println("Indicar nombre de la Poliza");
                           String archivo = io.next();
                           poliza1=obtenerPoliza(archivo);
                           respuesta=1;
                           break;
                     case 2:
                           //Crear Nueva Poliza
                           poliza1=new Poliza();
                           respuesta=1;
                           break;
                     default:
                          System.out.println("Opcion No valida");
                          respuesta=2;
                          break;
               }
        }while(respuesta!=1);



        do{
               System.out.println("Que accion desea realizar");
               System.out.println("1.Mostrar Poliza Creada");
               System.out.println("2.Crear Nueva Poliza");
               System.out.println("3.Guardar Poliza");
               System.out.println("4.Cargar Poliza");
               System.out.println("5.SALIR");
               respuesta = io.nextInt();
               switch(respuesta){
                     case 1:
                           //Mostrar datos de la Poliza
                           poliza1.ImprimirPoliza();
                           break;
                     case 2:
                           //Crear Nueva Poliza
                           poliza1=new Poliza();
                           break;
                     case 3:
                           //Guardar
                          String archivo = "Polizas";
                          Main.guardarPoliza(poliza1);
                          System.out.println("Poliza Guardada");
                          break;
                     case 4:
                           //Mostrar datos de la Poliza
                           System.out.println("Indicar nombre de la Poliza");
                           String archivo1 = io.next();
                           poliza1=obtenerPoliza(archivo1);
                           respuesta=1;
                           break;
                      case 5:
                           //Salir
                          System.out.println("ADIOS");
                          break;
                     default:
                          System.out.println("Opcion No valida");
                          break;
               }
        }while(respuesta!=5);
    }

  /**
  * Metodo para respaldar una poliza en memoria
  * @param poliza - Objeto de la clase Poliza a almacenar
  */
   private static void guardarPoliza( Poliza poliza){
	   	Poliza poliza1 = null;
	   	boolean existe = false;
	   	//Verificar si ya se ha creado el archivo
	   	try{
		  ObjectInputStream lector = new ObjectInputStream(new FileInputStream("Polizas"));
	      poliza1=(Poliza)lector.readObject();
	      existe=true;
        }catch(Exception e){
          existe=false;
	    }
	    //Si no se ha creado
    	if(!existe){
           try{
		      ObjectOutputStream escritor = new ObjectOutputStream(new FileOutputStream("Polizas",true));
		      escritor.writeObject(poliza);
		      escritor.flush();
		      escritor.close();
	       }catch(Exception e){
		      System.out.println("Error en la grabacion");
		      System.out.println(e);
	       }
	    //En caso de que ya exista
        }else{
		  try{
		      ObjectOutputStream escritor = new ObjectOutputStreamAppend(new FileOutputStream("Polizas",true));
		  	  escritor.writeObject(poliza);
		  	  escritor.flush();
		  	  escritor.close();
		  }catch(Exception e){
		  	  System.out.println("Error en la grabacion");
		  	  System.out.println(e);
	   }
	  }
   }

  /**
  * Metodo para obtener una poliza almacenada en memoria
  * @param nombre - nombre con que se identifica el objeto buscado
  * @param Poliza - objeto que se habia almacenado en memoria
  */
   private static Poliza obtenerPoliza(String nombre){
	   Poliza poliza = null;
	   boolean buscando=true;
	   try{
		  ObjectInputStream lector = new ObjectInputStream(new FileInputStream("Polizas"));
		  poliza=(Poliza)lector.readObject();
		  while(poliza!=null&&buscando){
		         String nombre1 = poliza.obtenerCliente().obtenerNombre()+"."+poliza.obtenerCliente().obtenerApellido();
		         if(nombre.equals(nombre1)){
					 buscando = false;
				 }else{
					 poliza=(Poliza)lector.readObject();
			     }
		  }
		   lector.close();
	   }catch(EOFException e){
		   poliza =null;
		   System.out.println("No se encontro la poliza con ese nombre");
	   }catch(Exception e){
		   System.out.println("Error en la lectura");
		   System.out.println(e);
	   }
       return poliza;
   }

}